#include <stdio.h>
#include <stdlib.h>
#include <time.h> 

#define A 1
#define B 2

double simulate(){
    double pswitch=0.3;

    double current_time=0.0;

    double stateA=0.0;

    double stateB=0.0;

    int active=A;

    srand(time(NULL));
    while (stateA<1.0 && stateB<1.0)
    {
        double rswitch=((double)rand())/(RAND_MAX);
        if(rswitch<pswitch){
            current_time+=0.2;
            active=(active==A)?B:A;
        }

        if(active==A)
            stateA+=0.02;
        else
            stateB+=0.02;

        current_time+=0.04;
    }
    if(stateA<1.0){
        current_time+=(1-stateA)*2;
    }
    if(stateB<1.0){
        current_time+=(1-stateA)*2;
    }
    return current_time;
}

int main(){

    int number_of_tries=10000000;
    double sum=0;

    for(int i=0;i<number_of_tries;i++){
        sum+=simulate();
    }
    
    printf("Expected time to finish both tasks: %lf ms\n",(sum/number_of_tries));
    return 0;
}